#ModelSwarm.py
import Tools
from Bug import *
from ActionGroup import *



class ModelSwarm:
    def __init__(self, nBugs, worldXSize, worldYSize):
        # the environment
        self.nBugs = nBugs
        self.bugList = []

        self.worldXSize= worldXSize
        self.worldYSize= worldYSize

    # objects
    def buildObjects(self):
        for i in range(self.nBugs):
            aBug = Bug(i, random.randint(0,self.worldXSize-1), 
                    random.randint(0,self.worldYSize-1), self.worldXSize,
                    self.worldYSize)
            self.bugList.append(aBug)
        print

    # actions
    def buildActions(self):

        self.actionGroup1 = ActionGroup ("move")
        def do1(address):

            actionDictionary[self.actionGroup1.getName()]=self.actionGroup1

            # keep safe the original list
            address.bugListCopy=address.bugList[:]
            # never in the same order (please comment if you want to keep
            # always the same sequence
            random.shuffle(address.bugListCopy)
            # move with a jump, to have to transfer a parameter
            # the format is: collection, method, parameters by name
            # ask each agent, without parameters
            # the potential jump is the same for all the agents
            askEachAgentIn(address.bugListCopy,Bug.randomWalk,
                                        jump=random.uniform(0,5))

            self.actionGroup1.execLocalCode()

        self.actionGroup1.do = do1 # do is a variable linking a method
    

        # schedule
        self.actionList = [["move"]]

        # or
        #self.actionList = [["move"],[]]


    # run a step
    def step(self):

            step=extractAStepAndRotate(self.actionList)

            while len(step)>0:
                subStep=extractASubStep(step)


                if subStep == "move":
                    self.actionGroup1.do(self)
                    # self here is the model env.
                    # not added automatically
                    # being do a variable

    # bug list
    def getBugList(self):
        return self.bugList
